<template>
  <BasicModal
    v-bind="$attrs"
    destroyOnClose
    @register="registerModal"
    :title="getTitle"
    :width="width"
    @ok="handleSubmit"
    :showFooter="true"
  >
    <BasicForm @register="registerForm" layout="vertical" class="!px-6 !pt-4" />
  </BasicModal>
</template>
<script lang="ts" setup>
  import { ref, computed, unref } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { dataFormSchema } from './data';

  import {
    bedScheduledMemoAdd,
    bedScheduledMemoEdit,
    bedScheduledMemoDetail,
  } from '/@/api/biz/bed/scheduledMemoApi';
  import dayjs from 'dayjs';

  const emit = defineEmits(['success', 'register']);

  const getTitle = computed(() => (!unref(isUpdate) ? '新增排床备忘录' : '编辑排床备忘录'));
  const width = '30%';
  const isUpdate = ref(false);
  const rowId = ref();

  const { createMessage } = useMessage();
  const [registerForm, { setFieldsValue, resetFields, validate }] = useForm({
    labelWidth: 100,
    schemas: dataFormSchema,
    showActionButtonGroup: false,
    actionColOptions: {
      span: 23,
    },
  });
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async data => {
    await resetFields();
    setModalProps({ confirmLoading: false });
    isUpdate.value = !!data?.isUpdate;

    if (unref(isUpdate)) {
      const resData = await bedScheduledMemoDetail(data.record.id);
      rowId.value = resData.id;
      await setFieldsValue({
        ...resData,
      });
    } else {
      await setFieldsValue({
        appointmentDate: dayjs().format('YYYY-MM-DD'),
      });
    }
  });

  // 提交按钮事件
  async function handleSubmit() {
    try {
      const values = await validate();
      console.log('🚀 ~ file: FormModal.vue:66 ~ handleSubmit ~ values:', values);
      setModalProps({ confirmLoading: true });
      values.appointmentSailingsSort = values.appointmentSailingsSort.sort();
      !unref(isUpdate)
        ? await bedScheduledMemoAdd({ ...values })
        : await bedScheduledMemoEdit({ ...values, id: rowId.value });
      !unref(isUpdate) ? createMessage.success('新增成功！') : createMessage.success('编辑成功！');
      closeModal();
      emit('success', {
        isUpdate: unref(isUpdate),
        values: { ...values, id: rowId.value },
      });
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>
